
#include <iostream>
#include <string>

using namespace std;

#include "Connect4.h"
#include "Player.h"

int main()
{
	Connect4StateEvaluator evaluator_Red;
	Connect4GameStateFeature evaluatorWeights_Red;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_DOUBLE] = -0.6;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_DOUBLE] = 0.4;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_TRIPLE] = -1.5;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_TRIPLE] = 0.5;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_QUAD] = -5.5;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_QUAD] = 0.9;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::BLACK_CENTER] = -0.5;
	evaluatorWeights_Red.feature[Connect4GameStateFeature::RED_CENTER] = 0.5;
	evaluator_Red.setWeights(evaluatorWeights_Red);

	Connect4StateEvaluator evaluator_Black;
	Connect4GameStateFeature evaluatorWeights_Black;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_DOUBLE] = 0.4;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_DOUBLE] = -0.6;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_TRIPLE] = 0.5;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_TRIPLE] = -1.5;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_QUAD] = 0.9;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_QUAD] = -5.5;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::BLACK_CENTER] = 0.5;
	evaluatorWeights_Black.feature[Connect4GameStateFeature::RED_CENTER] = -0.5;
	evaluator_Black.setWeights(evaluatorWeights_Black);

	std::vector<game::Player<Connect4GameState, Connect4StateEvaluator>*> players(2);
	int BLACK_PLAYER = 0;
	int RED_PLAYER = 1;

	std::string playerName;
	std::cout << "\nConnect4 Game\n\n" << std::endl;
	std::cout << "Select Black Player<1> (type 'AI' for AI player): ";
	getline(cin,playerName);

	if(playerName == "AI")
	{
		players[BLACK_PLAYER] = new game::AIPlayer<Connect4GameState, Connect4StateEvaluator>();
		players[BLACK_PLAYER]->setEvaluator(evaluator_Black);
		std::cout << "\tEnter search depth(1-8): ";
		int depth;
		std::cin >> depth;
		while(depth < 1 || depth > 8)
		{
			std::cout << "\tEnter search depth(1-8): ";
			std::cin >> depth;
		}
		players[BLACK_PLAYER]->setDepth(depth);
	}
	else
	{
		players[BLACK_PLAYER] = new game::HumanPlayer<Connect4GameState, Connect4StateEvaluator>();
	}
	getline(cin,playerName);
	std::cout << "Select Red Player<2> (type 'AI' for AI player): ";
	getline(cin,playerName);

	if(playerName == "AI")
	{
		players[RED_PLAYER] = new game::AIPlayer<Connect4GameState, Connect4StateEvaluator>();
		players[RED_PLAYER]->setEvaluator(evaluator_Red);
		std::cout << "\tEnter search depth(1-8): ";
		int depth;
		std::cin >> depth;
		while(depth < 1 || depth > 8)
		{
			std::cout << "\tEnter search depth(1-8): ";
			std::cin >> depth;
		}
		players[RED_PLAYER]->setDepth(depth);
	}
	else
	{
		players[RED_PLAYER] = new game::HumanPlayer<Connect4GameState, Connect4StateEvaluator>();
	}

	Connect4Game c4game(players);
	int winner = c4game.play();

	system("PAUSE");
	return 0;
}
